<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2006 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.4
  $Source: /cvsroot/coppermine/stable/upload.php,v $
  $Revision: 1.21 $
  $Author: gaugau $
  $Date: 2006/02/24 13:30:07 $
  ********************************************
  Coppermine version: ?
  $Source: /cvsroot/coppermine/stable/jupload.php,v $
  $Revision: ?
  $Author: Etienne Gauthier
  $Date: ?
**********************************************/


//####################################################################################################
//#################################     INCLUDES    ##################################################
//####################################################################################################

// Confirm we are in Coppermine and set the language blocks.
define('IN_COPPERMINE', true);
//Let's also include the upload text.
define('JUPLOAD_PHP', true);
// Activate more language block sets.
define('UPLOAD_PHP', true);
define('DB_INPUT_PHP', true);
define('ADMIN_PHP', true);
define('EDITPICS_PHP', true);

// Call basic functions, etc.
require('include/init.inc.php');
require('include/picmgmt.inc.php');
require('plugins/jupload/include/gui.inc.php');

//Localisation. Handled from specific files, to make upgrade of coppermine easier:
//First: we load the default text (english)
require('plugins/jupload/lang/english.php');
trigger_error($lang_translation_info);
//Then, you overload with the choosen language, for existing translations.
$bJuploadTranslactionExist = file_exists('plugins/jupload/lang/' . $USER['lang'] . '.php'); 
if ($bJuploadTranslactionExist) {
    require('plugins/jupload/lang/' . $USER['lang'] . '.php');
}
	
// Some placeholders.
$customize = CUSTOMIZE_UPLOAD_FORM;
$user_form = USER_UPLOAD_FORM;
$allowed_URI_boxes = NUM_URI_BOXES;
$allowed_file_boxes = NUM_FILE_BOXES;

// Check to see if user can upload pictures.  Quit with an error if he cannot.
if (!USER_CAN_UPLOAD_PICTURES) {
    cpg_die(ERROR, $lang_jupload_php['perm_denied'], __FILE__, __LINE__);
}
// Globalize $CONFIG.
global $CONFIG, $lang_jupload_php, $user_form, $max_file_size;

//####################################################################################################
//#################################    FUNCTIONS    ##################################################
//####################################################################################################

//Insert an album into database, if the user is allowed to.
//The category is given into $cat. It's mandatory if the galery is in admin mode.
function create_album($album, $album_name, $album_description, $cat='') {
  global $lang_errors, $CONFIG, $lang_jupload_php;
  if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

  if ($album_name == '') cpg_die(ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);

  if (GALLERY_ADMIN_MODE) {
    if ($cat == '') cpg_die(ERROR, $lang_errors['param_missing'], __FILE__, __LINE__);
    $category = (int)$_POST['cat'];
  } else {
    $category = FIRST_USER_CAT + USER_ID;
  }

  //We first check that the user doesn't already own an album with this name
  $vQuery = "SELECT count(*) nb "
    		. " FROM {$CONFIG['TABLE_ALBUMS']} " 
    		. " WHERE category = '$category'"
    		. " AND   title = '" . addslashes($album_name) . "'";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);
  if ($vRes['nb'] > 0) cpg_die(ERROR, $lang_jupload_php['error_album_already_exists'], __FILE__, __LINE__);

  //Let's insert the new album.
  $query = "INSERT INTO {$CONFIG['TABLE_ALBUMS']} (category, title, description, uploads, pos) "  
    . " SELECT '$category', '" . addslashes($album_name) . "', '" . addslashes($album_description) . "', 'NO',  IFNULL(MAX(pos),101) "
    . " FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$category' ";
  cpg_db_query($query);
  
  //Now, we select its id, to redirect the user to this album.
  $vQuery = "SELECT aid "
    		. " FROM {$CONFIG['TABLE_ALBUMS']} " 
    		. " WHERE category = '$category'"
    		. " AND   title = '" . addslashes($album_name) . "'";
  $vRes = cpg_db_query($vQuery);
  $vRes = mysql_fetch_array($vRes);

  message_success("create_album", $vRes['aid']);
}//create_album

//Update an album into database, if the user is allowed to.
function update_album($album, $album_name, $album_description) {
  global $lang_errors, $CONFIG;
  if (!(GALLERY_ADMIN_MODE || USER_ADMIN_MODE)) cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);

  if (USER_ADMIN_MODE) {
    //The user may only update its own albums. 
    $category = FIRST_USER_CAT + USER_ID;
    $user_albums = cpg_db_query("SELECT 1 FROM {$CONFIG['TABLE_ALBUMS']} WHERE category = '$category'");
    if (! mysql_num_rows($user_albums)) {
      cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
    }
  }
  
  $query = "UPDATE {$CONFIG['TABLE_ALBUMS']} SET title='" . addslashes($album_name) 
  	. "', description='" . addslashes($album_description) . "' WHERE aid='$album' $restrict LIMIT 1";
  cpg_db_query($query);
  message_success("update_album", $album);
}//update_album


/**
 * handle_picture_upload receive the upload http request. Its aim is to:
 * - Add the uploaded files into the database
 * - Calculate the thumb and normal picture.
 * - return a status to the applet, by writting one simple line. This return is:
 *     SUCCESS               (if everything is Ok)
 *     ERROR: Error message  (if some problem occurs)
 */
function handle_picture_upload() {
	global $album, $PIC_NEED_APPROVAL, $lang_db_input_php, $lang_upload_php, $escrow_array, $file_failure_array;

	$return = "Unknow return status";

	require('plugins/jupload/include/j_picmgmt.inc.php');

	//Let's read the _FILES array.
	handle_uploaded_files('userpicture');
	
	//The uploaded picture should come one by one.
	if (count($escrow_array) == 0) {
		$return = "ERROR: no file uploaded";
	} else if (count($escrow_array) > 1) {
		$return = "ERROR: too many files uploaded (" . count($escrow_array) . ")";
	} else {
		//Ok, one file has been uploaded.
		$file_placement = add_physical_file($album, $escrow_array[0]['actual_name'], $escrow_array[0]['temporary_name']);

        // Create the final message.
        if ($PIC_NEED_APPROVAL) {
            if ($file_placement == 'no') {
                $return = 'ERROR: ' . $lang_upload_php['no_place'];
            } else {
                $final_message = 'SUCCESS';
            }
        } else {
            if ($file_placement == 'no') {
                $final_message = 'ERROR: '.$lang_upload_php['no_place'];
            } else {
                $final_message = 'NEED APPROVAL';
            }
        }
		
		//Send a mail, if needed.
		after_upload();

		$return = "SUCCESS";
	}

	//We write the upload status, toward the applet. 	
	echo($return);

	//And that's all.
	exit;
}


///////////////////////////////////////////////////////////////////////
///////////////   INIT OF SCRIPT VARIABLES  ///////////////////////////
///////////////////////////////////////////////////////////////////////

//Initialize local parameters.
$action				= isset($_POST['action']			) ? $_POST['action'] 			: $_GET['action'];
$album				= isset($_POST['album']				) ? ( (int) $_POST['album']) 	: (isset($_GET['album'])?(int)$_GET['album']:0);
$album_name			= isset($_POST['album_name']		) ? $_POST['album_name'] 		: '';
$album_description	= isset($_POST['album_description'] ) ? $_POST['album_description'] : '';


// Get public and private albums, and set maximum individual file size.

if (GALLERY_ADMIN_MODE) {
    $public_albums = cpg_db_query("SELECT aid, title, description  FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " ORDER BY title");
} else {
	$public_albums = cpg_db_query("SELECT aid, title, description  FROM {$CONFIG['TABLE_ALBUMS']} WHERE category < " . FIRST_USER_CAT . " AND uploads='YES' AND (visibility = '0' OR visibility IN ".USER_GROUP_SET.") ORDER BY title");
}
if (mysql_num_rows($public_albums)) {
    $public_albums_list = cpg_db_fetch_rowset($public_albums);
} else {
    $public_albums_list = array();
}

if (USER_ID) {
    $user_albums = cpg_db_query("SELECT aid, title, description FROM {$CONFIG['TABLE_ALBUMS']} WHERE category='" . (FIRST_USER_CAT + USER_ID) . "' ORDER BY title");
    if (mysql_num_rows($user_albums)) {
        $user_albums_list = cpg_db_fetch_rowset($user_albums);
    } else {
        $user_albums_list = array();
    }
} else {
    $user_albums_list = array();
}

/*
if (!count($public_albums_list) && !count($user_albums_list)) {
    cpg_die (ERROR, $lang_upload_php['err_no_alb_uploadables'], __FILE__, __LINE__);
}
*/

// Assign maximum file size for browser crontrols.
//$max_file_size = $CONFIG['max_upl_size'] << 10;



if ($album_name == ''  && $album > 0) {
	//Let's get the album name and description for the selected album. 
	$found = false;
    foreach($user_albums_list as $a) {
    	if ($a['aid'] == $album) {
    		$found = true;
    		$album_name = $a['title'];
    		$album_description = $a['description'];
    	}
    }
    if (!$found) {
	    foreach($public_albums_list as $a) {
	    	if ($a['aid'] == $album) {
	    		$found = true;
	    		$album_name = $a['title'];
	    		$album_description = $a['description'];
	    	}
	    }
    }
}


//####################################################################################################
//################################# MAIN CODE BLOCK ##################################################
//####################################################################################################


///////////////////////////////////////////////////////////////////////
/////////////////   HANDLE OF INCOMING ACTIONS  (if any)  /////////////
///////////////////////////////////////////////////////////////////////

//Action that don't terminate the script:

switch ($action) {
case 'update_album':
	update_album($album, $album_name, $album_description);
	break;
case 'create_album';
	create_album($album, $album_name, $album_description);
	break;
}



//Now, we dispatch the control to the relevant page generator.

switch ($action) {
//First: generation of the standaed jupload page, containing the applet:
case 'update_album':
case 'create_album':
case '':
	require("plugins/jupload/upload_page.php");
	break;
//Upload of a picture from the applet. No HTML to generate.
case 'add_picture':
	handle_picture_upload();
	//We stop here: this action should only add a picture. 
	//handle_picture_upload already have done an exit. We add one here... we never knows.
	break;
//Edition of the properties of the uploaded pictures:
case 'edit_uploaded_pics':
	require("plugins/jupload/edit_uploaded_pics.php");
	break;
default:
	cpg_die ('Unknown action');
}


