<?php
/*
 * Author: Etienne Gauthier (etienne_sf@sourceforge.net)
 * 
 * Receive a picture uploaded by the jupload.php script (through the JUpload applet)
 * 
 * Up to date version of this script can be retrieved with the full JUpload package, here:
 * 
 * http://etienne.lesgauhthier.fr/wiki
 * 
 * Directly here:
 * http://etienne.lesgauthier.fr/wiki/doku.php?id=jupload_coppermine_download_gb
 * 
 * The applet is published on sourceforge:
 * http://jupload.sourceforge.net
 * 
 * 
 * This page is directly taken from the xp_publish.php page. Almost only the add_picture function as been 
 * incorporated here (all the other stuffs had been removed). So this script is light.
 * It had been updated, to remove the following xp_publish.php limit : a non admin user can not upload within
 * a category album (that is not a user's album), even if the admin authorize public upload to it.
 * The modification is marked be the 'EGR' tags.
 * 
 * This php script should be simple, but it seems that it's not possible to reuse any existing code :
 * - xp_publish can't be included. And it dosn't allow upload within admin albums, even if the admin authorized
 *   users to uploaded in it.
 * - db_input seems to be good enough. But all the treament of the uploaded file is within a code block that also
 *  do other stuff (accept all image comments). We don't have that here.
 */

// Declare we are in Coppermine.
define('IN_COPPERMINE', true);

// Set the language block.
define('JUPLOAD_PHP', true);

// Activate more language block sets.
define('LOGIN_PHP', true);
define('DB_INPUT_PHP', true);
define('ALBMGR_PHP', true);

// Call necessaryy files and subroutines.
//require('include/init.inc.php');
//require('include/picmgmt.inc.php');


echo ("within upload_picture.php (10)\n");



/*
// Set the log file path.
define('LOGFILE', 'xp_publish.log');


// ------------------------------------------------------------------------- //

if (USER_IS_ADMIN && !GALLERY_ADMIN_MODE) {
    $USER['am'] = 1;
    user_save_profile();
}

// ------------------------------------------------------------------------- //

// Simple die function (replace the cpg_die function that can't be used inside the wizard)
function error_die($msg_code, $msg_text, $error_file, $error_line)
{
    global $CONFIG, $lang_cpg_die;

    $msg = "ERROR [$msg_code]: $msg_text";

    if (!$CONFIG['debug_mode']) {
        $msg .= '(' . $lang_cpg_die['file'] . ': ' . $error_file . ' / ' . $lang_cpg_die['line'] . ': ' . $error_line . ')';
    }

    echo $msg;
    
    // If debug mode is active, write the output into a log file
    if (!$CONFIG['debug_mode']) {
        $ob = ob_get_contents();
        fwrite(fopen(LOGFILE, 'w'), $ob);
    }

    exit;
}

//////////////////////////////////////////////////////////////////////////:
// Let's add the picture
//////////////////////////////////////////////////////////////////////////:
function process_uploaded_picture()
{
    global $CONFIG, $IMG_TYPES;
    global $lang_db_input_php, $lang_errors;

	
	@unlink(LOGFILE);
	
	if (!USER_ID || !USER_CAN_UPLOAD_PICTURES) { 
		error_die('perm_denied', $lang_errors['perm_denied'], __FILE__, __LINE__);
	}
	
	// Test if the filename of the temporary uploaded picture is empty
	// For instance, it will be empty if no picture where uploaded.
	if ($_FILES['userpicture']['tmp_name'] == '') { 
		error_die('no_pic_uploaded', $lang_db_input_php['no_pic_uploaded'], __FILE__, __LINE__);
	}

	$album = (int)$_GET['album'];
	$title = '';
	$caption = '';
	$keywords = '';
	$user1 = '';
	$user2 = '';
	$user3 = '';
	$user4 = '';
	$position = 0;
	
	// Check if the album id provided is valid
	if (!USER_IS_ADMIN) {
	    //EGR 40 (start)
	    //$result = cpg_db_query("SELECT category FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid='$album' and category = '" . (USER_ID + FIRST_USER_CAT) . "'");
	    $result = cpg_db_query(
					"SELECT category FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid='$album' "
					. " and (    category = '" . (USER_ID + FIRST_USER_CAT) . "') "
	    					. " or "
	    			. "     )"
	    	A finir
	    	);
	    //EGR 40 (end)
	    if (mysql_num_rows($result) == 0) { 
	    	error_die('unknown_album', $lang_db_input_php['unknown_album'], __FILE__, __LINE__);
		}
	    $row = mysql_fetch_array($result);
	    mysql_free_result($result);
	    $category = $row['category'];
	} else {
	    $result = cpg_db_query("SELECT category FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid='$album'");
	    if (mysql_num_rows($result) == 0) { 
	    	error_die('unknown_album', $lang_db_input_php['unknown_album'], __FILE__, __LINE__);
	    }
	    $row = mysql_fetch_array($result);
	    mysql_free_result($result);
	    $category = $row['category'];
	}
	
	// Get position
	$result = cpg_db_query("SELECT position FROM {$CONFIG['TABLE_PICTURES']} WHERE aid='$album' order by position desc");
	if (mysql_num_rows($result) == 0) {
	         $position = 100;
	} else {
	         $row = mysql_fetch_array($result);
	         mysql_free_result($result);
	                 if ($row['position']) {
	                 $position = $row['position'];
	                         $position++;
	                                     }
	}
	
	// Create destination directory for pictures
	if (USER_ID && !defined('SILLY_SAFE_MODE')) {
	    if (USER_IS_ADMIN && ($category != (USER_ID + FIRST_USER_CAT))) {
	        $filepath = 'wpw-' . date("Ymd");
	    } else {
	        $filepath = $CONFIG['userpics'] . (USER_ID + FIRST_USER_CAT);
	    }
	    $dest_dir = $CONFIG['fullpath'] . $filepath;
	    if (!is_dir($dest_dir)) {
	        mkdir($dest_dir, octdec($CONFIG['default_dir_mode']));
	        if (!is_dir($dest_dir)) { 
	        	error_die('err_mkdir', sprintf($lang_db_input_php['err_mkdir'], $dest_dir), __FILE__, __LINE__);
	    	}
	        chmod($dest_dir, octdec($CONFIG['default_dir_mode']));
	        $fp = fopen($dest_dir . '/index.html', 'w');
	        fwrite($fp, ' ');
	        fclose($fp);
	    }
	    $dest_dir .= '/';
	    $filepath .= '/';
	} else {
	    $filepath = $CONFIG['userpics'];
	    $dest_dir = $CONFIG['fullpath'] . $filepath;
	}
	// Check that target dir is writable
	if (!is_writable($dest_dir)) {
		error_die('dest_dir_ro', sprintf($lang_db_input_php['dest_dir_ro'], $dest_dir), __FILE__, __LINE__);
	}
	
	$matches = array();
	
	//EGR 10
	if (get_magic_quotes_gpc()) { 
		$_FILES['userpicture']['name'] = stripslashes($_FILES['userpicture']['name']);
	}
	//if (get_magic_quotes_gpc()) $_FILES['userpicture']['name'] = stripslashes(urldecode($_FILES['userpicture']['name']));
	//Fin EGR 10
	
	// Replace forbidden chars with underscores
	//EGR 20
	//$picture_name = replace_forbidden($_FILES['userpicture']['name']);
	
	//$picture_name = urldecode($_FILES['userpicture']['name']);
	$picture_name = $_FILES['userpicture']['name'];
	$picture_name = replace_forbidden($picture_name);
	//$picture_name = replace_forbidden(imap_utf8($_FILES['userpicture']['name']));
	//$picture_name = replace_forbidden(mb_convert_encoding($_FILES['userpicture']['name'], "auto", "UTF-8"));
	echo("Final value for picture_name: ${picture_name}\r\n");
	//Fin EGR 20
	// Check that the file uploaded has a valid extension
	if (!preg_match("/(.+)\.(.*?)\Z/", $picture_name, $matches)) {
	    $matches[1] = 'invalid_fname';
	    $matches[2] = 'xxx';
	}
	
	if ($matches[2] == '' || !is_known_filetype($matches)) {
	    error_die('err_invalid_fext', sprintf($lang_db_input_php['err_invalid_fext'], $CONFIG['allowed_file_extensions']), __FILE__, __LINE__);
	}
	
	// Create a unique name for the uploaded file
	$nr = 0;
	$picture_name = $matches[1] . '.' . $matches[2];
	while (file_exists($dest_dir . $picture_name)) {
	    $picture_name = $matches[1] . '~' . $nr++ . '.' . $matches[2];
	}
	$uploaded_pic = $dest_dir . $picture_name;
	// Move the picture into its final location
	if (!move_uploaded_file($_FILES['userpicture']['tmp_name'], $uploaded_pic)) {
	    error_die('err_move', sprintf($lang_db_input_php['err_move'], $picture_name, $dest_dir), __FILE__, __LINE__);
	}
	// Change file permission
	chmod($uploaded_pic, octdec($CONFIG['default_file_mode']));
	
	// Check file size. Delete if it is excessive.
	if (filesize($uploaded_pic) > ($CONFIG['max_upl_size'] << 10)) {
	    @unlink($uploaded_pic);
	    error_die('err_imgsize_too_large', sprintf($lang_db_input_php['err_imgsize_too_large'], $CONFIG['max_upl_size']), __FILE__, __LINE__);
	} elseif (is_image($picture_name)) {
	
	    // Get picture information
	    $imginfo = getimagesize($uploaded_pic);
	
	    // getimagesize does not recognize the file as a picture
	    if ($imginfo == null) {
	        @unlink($uploaded_pic);
	        error_die('err_invalid_img', $lang_db_input_php['err_invalid_img'], __FILE__, __LINE__);
	    }
	
	    // JPEG and PNG only are allowed with GD
	    //if ($imginfo[2] != GIS_JPG && $imginfo[2] != GIS_PNG && ($CONFIG['thumb_method'] == 'gd1' || $CONFIG['thumb_method'] == 'gd2')) {
	    if ($imginfo[2] != GIS_JPG && $imginfo[2] != GIS_PNG && $CONFIG['GIF_support'] == 0) {
	        @unlink($uploaded_pic);
	        error_die('gd_file_type_err', $lang_errors['gd_file_type_err'], __FILE__, __LINE__);
	    }
	
	    // Check that picture size (in pixels) is lower than the maximum allowed
	    if (max($imginfo[0], $imginfo[1]) > $CONFIG['max_upl_width_height']) {
	        if ((USER_IS_ADMIN && $CONFIG['auto_resize'] == 1) || (!USER_IS_ADMIN && $CONFIG['auto_resize'] > 0)) { //($CONFIG['auto_resize']==1) 
	          //resize_image($uploaded_pic, $uploaded_pic, $CONFIG['max_upl_width_height'], $CONFIG['thumb_method'], $imginfo[0] > $CONFIG['max_upl_width_height'] ? 'wd' : 'ht');
	          resize_image($uploaded_pic, $uploaded_pic, $CONFIG['max_upl_width_height'], $CONFIG['thumb_method'], $CONFIG['thumb_use']);
	        }
	        else {
	          @unlink($uploaded_pic);
	          error_die('err_fsize_too_large', sprintf($lang_db_input_php['err_fsize_too_large'], $CONFIG['max_upl_width_height'], $CONFIG['max_upl_width_height']), __FILE__, __LINE__);
	        }
	    }
	
	}
	
	// Create thumbnail and internediate image and add the image into the DB
	$result = add_picture($album, $filepath, $picture_name, $position, $title, $caption, $keywords, $user1, $user2, $user3, $user4, $category);
	
	if (!$result) {
	    @unlink($uploaded_pic);
	    error_die('err_insert_pic', sprintf($lang_db_input_php['err_insert_pic'], $uploaded_pic), __FILE__, __LINE__);
	} else {
	    echo ("SUCCESS\n");
	}
} //process_uploaded_picture

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Let's go.... and hope, that, in the future, we can reuse a global function and not a copied/pasted one ! 
process_picture();
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


*/


////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Position of parameter, for handling by the db_input.php script.
$_POST['event'] = 'picture';
$_POST['album'] = (int)$_GET['album'];
$_POST['title'] = '';
$caption = addslashes($_POST['caption']);
$keywords = addslashes($_POST['keywords']);
$user1 = addslashes($_POST['user1']);
$user2 = addslashes($_POST['user2']);
$user3 = addslashes($_POST['user3']);
$user4 = addslashes($_POST['user4']);

echo ("within upload_picture.php (1000)\n");

require(db_input.php);

echo ("SUCCESS\n");